package com.santi.pmdm.virgen.dogapicleanarchitecture.data.datasource.mem.service

import com.santi.pmdm.virgen.dogapicleanarchitecture.data.datasource.mem.models.Dogs
import com.santi.pmdm.virgen.dogapicleanarchitecture.domain.mapper.toDog
import com.santi.pmdm.virgen.dogapicleanarchitecture.domain.models.Dog
import javax.inject.Inject

/*
Esta clase, simula el servicio de acceso a los datos nativos.
IMAGINAMOS QUE PAIR, SERÍA LO MÁS PARECIDO A UN REGISTRO DE LA BASE DE DATOS.
 */

class DogService @Inject constructor(): DogServiceInterface {
    override fun getDogs(): List<Dog> {
        return Dogs.dogs.map { it.toDog() }
    }

    /*
    Aquí, estoy filtrando por raza. Simulo un acceso por filtro.
     */
    override fun getBreedDogs(breed: String): List<Dog> {
        val newDogs = Dogs.dogs.map{it.toDog()}.filter {
            it.breed == breed
        }
        return newDogs
    }

}